//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers    6
#property  indicator_color1    Yellow
#property  indicator_color2    Aqua
#property  indicator_color3    Aqua
#property  indicator_color4    Lime
#property  indicator_color5    Red
#property  indicator_color6    Red
#property  indicator_width1    3
#property indicator_minimum    0
#property indicator_maximum    100
#property indicator_levelcolor Gold


//
//
//
//
//

extern string TimeFrame = "current time frame";
extern int    Price     = 0;
extern double RsxLength = 14;
extern int    MaPeriod  = 21;
extern int    MaMethod  = 1;
extern int    koridor   = 5;
extern bool   drawDots  = true;   
extern double levelOs   = 15;
extern double levelOb   = 85;

//
//
//
//
//

double rsx[];
double upBand[];
double dnBand[];
double rsxMaDa[];
double rsxMaDb[];
double rsxMa[];
double trend[];
double wrkBuffer[][13];

//
//
//
//
//

int    timeFrame;
string indicatorFileName;
string shortName;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,rsx); 
   SetIndexBuffer(1,upBand);
   SetIndexBuffer(2,dnBand); 
   SetIndexBuffer(3,rsxMa);    
   SetIndexBuffer(4,rsxMaDa);
   SetIndexBuffer(5,rsxMaDb);  
   SetIndexBuffer(6,trend);
   SetLevelValue(0,levelOs); 
   SetLevelValue(1,levelOb);
   
   if (drawDots) 
   {
     SetIndexStyle(3, DRAW_ARROW,0); SetIndexArrow(3, 110);
     SetIndexStyle(4, DRAW_ARROW,0); SetIndexArrow(4, 110);
     SetIndexStyle(5, DRAW_NONE);
   }
   else
   {
     SetIndexStyle(3, DRAW_LINE);
     SetIndexStyle(4, DRAW_LINE);
     SetIndexStyle(5, DRAW_LINE);
   }        
            
      //
      //
      //
      //
      //
         RsxLength         = MathMax(1,RsxLength);
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
   IndicatorShortName(timeFrameToString(timeFrame)+ "  Tarzan ("+DoubleToStr(RsxLength,2)+","+MaPeriod+")");
   SetIndexLabel(0,"");
   SetIndexLabel(1,"");
   SetIndexLabel(2,"");
   SetIndexLabel(3,"");
   SetIndexLabel(4,"");
   SetIndexLabel(5,"");
   return(0);
}

int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars - counted_bars,Bars-1);
         if (returnBars) { rsx[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
     double Kg = (3.0)/(2.0+RsxLength);
     double Hg = 1.0-Kg;
     if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);
     for (i=limit, r=Bars-i-1; i>=0; i--, r++)
     {
        wrkBuffer[r][12] = iMA(NULL,0,1,0,MODE_SMA,Price,i); 

        if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

       //
       //
       //
       //
       //
      
       double roc = wrkBuffer[r][12] - wrkBuffer[r-1][12];
       double roa = MathAbs(roc);
       for (int k=0; k<3; k++)
       {
          int kk = k*2;
             wrkBuffer[r][kk+0] = Kg*roc                + Hg*wrkBuffer[r-1][kk+0];
             wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; roc = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
             wrkBuffer[r][kk+6] = Kg*roa                + Hg*wrkBuffer[r-1][kk+6];
             wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; roa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
       }
       if (roa != 0)
            rsx[i] = MathMax(MathMin((roc/roa+1.0)*50.0,100.00),0.00); 
       else rsx[i] = 50.0; 
   }
   
   if (!drawDots) if (trend[limit] == -1) ClearPoint(limit,rsxMaDa,rsxMaDb);
   for (i=limit; i>=0; i--) 
   {
      rsxMa[i]  = iMAOnArray(rsx,0,MaPeriod,0,MaMethod,i);
      upBand[i] = iMAOnArray(rsx,0,MaPeriod,0,MaMethod,i)+koridor;
      dnBand[i] = iMAOnArray(rsx,0,MaPeriod,0,MaMethod,i)-koridor;
      rsxMaDa[i] = EMPTY_VALUE;
      rsxMaDb[i] = EMPTY_VALUE;
      trend[i]   = trend[i+1];
         if (rsx[i]>rsxMa[i]) trend[i]= 1;
         if (rsx[i]<rsxMa[i]) trend[i]=-1;
         if (trend[i]==-1) if    (drawDots) rsxMaDa[i] = rsxMa[i];
                           else  PlotPoint(i,rsxMaDa,rsxMaDb,rsxMa);
   }
   return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (trend[limit]==-1) ClearPoint(limit,rsxMaDa,rsxMaDb);
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         rsx[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,RsxLength,MaPeriod,MaMethod,koridor,0,y);
         upBand[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,RsxLength,MaPeriod,MaMethod,koridor,1,y);
         dnBand[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,RsxLength,MaPeriod,MaMethod,koridor,2,y);
         rsxMa[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,RsxLength,MaPeriod,MaMethod,koridor,3,y);
         rsxMaDa[i] = EMPTY_VALUE;
         rsxMaDb[i] = EMPTY_VALUE;
         trend[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,RsxLength,MaPeriod,MaMethod,koridor,6,y);
         
         if (drawDots && trend[i]==-1) rsxMaDa[i] = rsxMa[i];
         
      
   }
   if (!drawDots) for(i=limit; i>=0; i--) if (trend[i]== -1) PlotPoint(i,rsxMaDa,rsxMaDb,rsxMa);
return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//
//
//
//
//


